#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sysexits.h>

#ifdef	HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

#include <strfunc.h>

#include "lgba.h"

char *usenode, *object;
slist *nodes;
slist *classes;
slist *class;

int
tryReadConfig(char *name) {
	struct stat sb;

	if(!name) {
		if(
			tryReadConfig("./lgba.cgi.conf") &&
			tryReadConfig("/usr/local/etc/lgba.cgi.conf")
		) return -1;
		return 0;
	};

	if( stat(name, &sb) )
		return -1;

	if( (sb.st_mode & S_IFMT) != S_IFREG )
		return -1;

	return cfgread(name);
};

char *
option_nodes() {
	sbuf *sb;
	char *buf;
	int i;
	char *un=usenode;
	char *fr, *ll;

	if(!un) un="";

	sb = sbuf_init();

	for(i=0; i<nodes->count; i++) {
		ll=nodes->list[i];
		fr=lgba_map_friendly(ll);
		sbuf_sprintf(sb, "<OPTION VALUE=\"%s\"%s>%s\n",
			ll, ecq(ll, un)?" selected=on":"", fr);
	}

	buf = sb->buf;
	free(sb);
	return buf;
};

