#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include "intern.h"

#define INQ	1
#define OUTQ 2

char **
lgba_explode_dn(char *dn)
{
	char	*p, *q, *rdnstart, **rdns = NULL;
	int	state, count = 0, endquote, len;

	rdnstart = dn;
	p = dn-1;
	state = OUTQ;

	do {

		++p;
		switch ( *p ) {
		case '\\':
			if (*++p == '\0') p--;
			break;
		case '"':
			if (state == INQ) state = OUTQ;
			else state = INQ;
			break;
		case ';':
		case ',':
		case '\0':
			if (state == OUTQ) {
				++count;
				if (rdns == NULL) {
					if (( rdns = (char **)sf_malloc(
						8 * sizeof( char *))) == NULL )
						return( NULL );
				} else if ( count >= 8 ) {
					if (( rdns = (char **)sf_realloc( rdns,
						(count+1) * sizeof( char *)))
						== NULL )
						return( NULL );
				}
				rdns[ count ] = NULL;
				endquote = 0;
				for ( q = rdnstart;
				    q < p && *q != '='; ++q ) {
					;
				}
				if ( q < p ) {
					rdnstart = ++q;
				}
				if ( *rdnstart == '"' ) {
					++rdnstart;
				}
				
				if ( *(p-1) == '"' ) {
					endquote = 1;
					--p;
				}

				len = p - rdnstart;
				if (( rdns[ count-1 ] = (char *)calloc( 1,
				    len + 1 )) != NULL ) {
				    	memmove( rdns[ count-1 ], rdnstart, len );
					rdns[ count-1 ][ len ] = '\0';
				}

				if (endquote == 1) p++;

				rdnstart = *p ? p + 1 : p;
				while ( isspace( *rdnstart ))
					++rdnstart;
			}
			break;
		}
	} while (*p);

	return(rdns);
}
