$Id: sendmail.howto.ru,v 1.7 2001/08/09 09:41:21 vlm Exp $


===
Q.   sendmail    LDAP?
A.    .

===
Q.     ?
A. ,   ,  .  
     .

===
Q.    ?
A.      sendmail' ,   
  LDAP (LDAPMAP).      
 sendmail.   ,  sendmail-8.11.x, 
      ./devtools/Site/site.config.m4, 
   :

	APPENDDEF(`confMAPDEF', `-DLDAPMAP')
	APPENDDEF(`confLIBS', `-L/usr/local/lib -lldap -llber')
	APPENDDEF(`confINCDIRS', `-I/usr/local/include')

 sendmail    .


===
Q.    ?
A.       sendmail.cf
(/etc/mail/sendmail.cf)    
(/etc/mail/mailertable, et cetera).

===
Q.     sendmail.cf?
A.      ,    
  sendmail'  "  ", 
"         ( 
,   )".

===
Q.        sendmail.cf?
A.    ,     sendmail.cf,
    .     ,
     .  ,   
   sendmail.cf  ,     
       .

================================================================================
       ( 0)
    (rulesets): ValidateLGBAUser ( 1)
 LGBAForwarding ( 2),      
,    sendmail.cf  .

 0.        (maps) 
  .

 1.  ValidateLGBAUser  ,   
 ,  email'    .
  , , ,  sendmail  
SMTP "MAIL FROM:"  "RCPT TO:",   :   
    .

 2.  LGBAForwarding  ,   
      .
       ,  
       "forward"-.
     sendmail    ,
       . 
( )     "-x"  
mail.local (   LGBA)  ,   
"forward"   .

        
 sendmail' rulesets.     -    
'S'    (/^S  vi).
--------------------------------------------------------------------------------


#==================================#
#=== Section 0: General options ===#
#==================================#

O LDAPDefaultSpec=-h localhost -b dc=company,dc=com

### Authentication within domains ###

Klgba_local ldap -k (&(uid=%0)(!(objectclass=Blocked))) -m -n
Klgba_local_fwd ldap -k (&(uid=%0)(forward=*)) -vForward -1 -z,

# Authenticate otherdomain.company.com and another.copnany.com
# against the same LDAP tree.

C{Other}otherdomain.company.com another.company.com
Klgba_other ldap -k (&(uid=%0)(!(objectclass=Blocked))) -1 -n -b dc=other,dc=company,dc=com
Klgba_other_fwd ldap -k (&(uid=%0)(forward=*)) -vForward -1 -z -b dc=other,dc=company,dc=com

### Default maximum message size ###

# Default 2MB message size limit.
D{MMS} 2000000

# Message size control maps
Klgba_msgsize_local ldap -k (&(uid=%0)(mailsizelimit=*)) -vMailSizeLimit
Klgba_msgsize_other ldap -k (&(uid=%0)(mailsizelimit=*)) -b dc=other,dc=company,dc=com -vMailSizeLimit

### Default maximum mailbox size ###

# Default 5MB mailbox size limit.
D{MBS} 5000000

# Message size control maps
Klgba_mboxsize_local_limit ldap -k (&(uid=%0)(mboxsizelimit=*)) -vMBoxSizeLimit
Klgba_mboxsize_other_limit ldap -k (&(uid=%0)(mboxsizelimit=*)) -b dc=other,dc=company,dc=com -vMBoxSizeLimit

Kls	program /bin/ls -sk

Kset macro
Kif arith

#===========================================#
#=== Section 1: ValidateLGBAUser ruleset ===#
#===========================================#

# [<RCode>]login<@domain>[$|<ReturnIfOK>]

SValidateLGBAUser

### prepare macros ###
### canonize to login<@domain> ###

R $*	$: $(set {ROK} $) $1
R$*$|$+	$: $(set {ROK} $@$2 $) $1
R $*	$: $(set {RCode} $) $1
R<$->$*	$: $(set {RCode} $@<$1> $) $2

R $*	$: $(set {Saved} $@ $1 $) $1

### Checking user authentity ###

R$+<@$=w>	$: $| $(lgba_local $1$:1 $)
R$+<@$={Other}>	$: $| $(lgba_other $1$:2 $)

R$*<@$*>	$@ $&{RCode} $&{Saved}	Not our user
R$|0	$@ $&{RCode} $&{Saved}	Definitely OK ;)
R$|1	$#error $@ NOUSER $: 550 User unknown
R$|2	$#error $@ 2.1.5 $: 215 Recipient ok	Fool the sender

R $*	$: $&{Saved}	Restore

R $*	$: $(if = $@ {ROK} $@ $) $1
RFALSE $*	$: $(set {RCode} $@ $&{ROK} $) $1

### Checking maximum message size limits ####

R $*	$: $&{Saved}	Restore

R$+<@$=w>	$: $| $(lgba_msgsize_local $1 $:$&{MMS} $)
R$+<@$={Other}>	$| $: $(lgba_msgsize_other $1 $:$&{MMS} $)

R$|0	$: FALSE	Unlimited
R$|$-	$: $(if l $@ $1 $@ $&{msg_size} $) $1
RTRUE$*	$#error $@ UNAVAILABLE $: 550 Message size exceeds user limit $1

### Checking mailbox size limits ####

R $*	$: $&{Saved}	Restore

R$+<@$=w>	$: $| $(lgba_mboxsize_local_limit $1 $:$&{MBS} $) $| $(ls "/var/mail/virtual/company.com/"$1 $:0 $)
R$+<@$={Other}>	$: $| $(lgba_mboxsize_other_limit $1 $:$&{MBS} $) $| $(ls "/var/mail/virtual/otherdomain.company.com/"$1 $:0 $)

R$|0$|$*	$: FALSE	Unlimited
R$|$-$|$-/$*	$: $|$1$|$2
R$|$-$|$-	$: $|$1$|$(arith * $@ 1024 $@ $2 $)	KBytes to bytes
R$|$-$|$-	$: $|$1$|$(arith + $@ $2 $@ $&{msg_size} $)	Virtually add msg 2 mbox

R$|$-$|$-	$: $(if l $@ $1 $@ $2 $) $1
RTRUE$*	$#error $@ UNAVAILABLE $: 550 Mailbox size exceeds user limit $1

### It was a hard day's night... ###
R $*	$@ $&{RCode} $&{Saved}

#=========================================#
#=== Section 2: LGBAForwarding ruleset ===#
#=========================================#

SLGBAForwarding

R $+ <@$=w.>	$: < $(lgba_local_fwd $1 $: $) > $1<@$2.>
R $+ <@$={Other}.>	$: < $(lgba_other_fwd $1 $: $) > $1<@$2.>
R<> $*	$@ $1	Forward not found

R<$*,$*> $*	$: $| <$1,$2> $3	Mark multiple forward values
R$| <$*> $*	$@ $2	Don't do anything with multiple forwards

R<$+> $*	$: $>Recurse $1	Substitute one value



================================================================================
       ruleset'.
     ,     
(ValidateLGBAUser  LGBAForwarding)     
  ,    .

     ValidateLGBAUser   ,
  SMTP- "MAIL FROM:"  "RCPT TO:".
Ruleset,    "MAIL FROM:"  check_mail,
   "RCPT TO:"  check_rcpt.

,   
R<$={Accept}> $+ < @ $+>	$: $>ValidateLGBAUser <$1>$2<@$3>$|<OK>
  check_mail,  
R$+ < @ $+ >	$: $>ValidateLGBAUser $1<@$2>$|<RELAY>
  check_rcpt.

  ValidateLGBAUser  check_mail:
	1.    check_mail (Scheck_mail)
	2.       (check results)
	3.       ,   :

	:

		...
	# check results
	R<?> $*			$: @ $1		mark address: nothing known about it
	R<OK> $*		$@ <OK>
		...

	:

		...
	# check results
	R<?> $*		$: @ $1		mark address: nothing known about it
	R<$={Accept}> $+ < @ $+>	$: $>ValidateLGBAUser <$1>$2<@$3>$|<OK>
	R<OK> $*		$@ <OK>
		...


  ValidateLGBAUser  check_rcpt:
	1.    check_mail (Scheck_rcpt)
	2.        
	3.       ,   :

	:

	...
	# anything terminating locally is ok
	R$+ < @ $=w >		$@ RELAYTO
	R$+ < @ $* $=R >	$@ RELAYTO
	R$+ < @ $+ >		$: $>LookUpDomain <$2> <?> <$1 < @ $2 >> <+To>
	R<RELAY> $*		$@ RELAYTO
	R<$*> <$*>		$: $2
	...

	:


	...

	R$+ < @ $+ >	$: $>ValidateLGBAUser $1<@$2>$|<RELAY>

	# anything terminating locally is ok
	R$+ < @ $=w >		$@ RELAYTO
	R$+ < @ $* $=R >	$@ RELAYTO
	R$+ < @ $+ >		$: $>LookUpDomain <$2> <?> <$1 < @ $2 >> <+To>
	R<RELAY> $*		$@ RELAYTO
	R<$*> <$*>		$: $2
	...


 LGBAForwarding,   (.   ),  
  ruleset Parse1 (SParse1)   
   :

	:

	...
	# short circuit local delivery so forwarded email works
	R$=L < @ $=w . >	$#local $: @ $1	special local names
	R$+ < @ $=w . >	$#local $: $1	regular local name
	...

	:

	...
	# handle LGBA forwarding
	R$+<@$+>	$: $>LGBAForwarding $1<@$2>
	R< $+ > $+ < @ $+ >	$: $>Recurse $1

	# short circuit local delivery so forwarded email works
	R$=L < @ $=w . >	$#local $: @ $1	special local names
	R$+ < @ $=w . >	$#local $: $1	regular local name
	...

--------------------------------------------------------------------------------


[   ,      ]



================================================================================
,  ,   (    
     rulesets)  , 
        sendmail.

,    sendmail     
 /etc/passwd    ,       (Mlocal)
  "w",      .
,    (   )   ,
   "w"    (F=...).  
   (.,   ,
    .,   
mail.local,    LGBA.

   ,   : local  lgba-other.
     (     
)   sendmail.cf -  .

  local    , 
  $=w (Cw  Fw  sendmail.cf).
   lgba-other,    /etc/mail/mailertable:

otherdomain.company.ru    lgba-mobile:Other

 ,     

another.company.ru    relay:[192.168.5.2]

   ,  sendmail,    
  another.company.ru   192.168.5.2    
 LDAP.

--------------------------------------------------------------------------------

Mlocal,		P=/usr/libexec/mail.local, F=5lsDFMSPhun9, S=EnvFromL/HdrFromL, R=EnvToL/HdrToL,
		T=DNS/RFC822/X-Unix,
		A=mail.local -x -m /var/mail/virtual/company.com -B -b /var/mail/virtual/company.com.backup -n Users -d company.com -f $f $u

Mlgba-other,	P=/usr/libexec/mail.local, F=lsmDFMSPhun9, S=EnvFromL/HdrFromL, R=EnvToL/HdrToL,
		T=DNS/RFC822/X-Unix,
		A=mail.local -m /var/mail/virtual/other.company.com -B -b /var/mail/virtual/othercompany.com.backup -n $h -f $f $u




===
Q.  ?
A. ,        .
  -    .



-- 
Lev Walkin, LMW28
vlm@spelio.net.ru
www.spelio.net.ru
