#ifndef	__INTERN_H__
#define __INTERN_H__

#include <sys/types.h>
#include <lber.h>
#include <ldap.h>
#include "lgba.h"

#include "readcf.h"

int lgba_internal_destroymodchain_s(answer *, int dosave);
void lgba_free_s(answer *);
char *lgba_internal_gendn(const char *);
char *lgba_internal_numericvalue(const char *, const char *);
int lgba_internal_rmtreefunc(int);
int lgba_internal_rmtree(char *);
int lgba_internal_setlocale();
char **lgba_internal_override(char *, void *);
char **lgba_internal_friendly_wrap(char *, void *);

int lgba_sort_entries(answer **, int count, char *, int(*cmp)(const char *, const char *));
int lgba_sort_entries2(answer **, int count, struct SortBy **);

int lgba_i_addmodchain(int, char *, void *);
int lgba_i_getincrementedvalue();
int xsystem(const char *cmd);

extern int lgba_i_override;
extern int lgba_i_counter;

extern int lgba_i_uselocale;
extern char *lgba_i_locale;

void _lgba_internal_warn(char *fmt, ...);

int lgba_i_fillanswer(answer *answer, LDAPMessage *en);

slist *getattr2_s(answer *, const char *);

#endif
